class Editor.EditorModule.DockModule.NewElementBoard extends Editor.EditorModule.DockModule.Board
  
  initialize: (options) ->
    super(options)
    @panel = @parent.dock().editor().panel
  
class Editor.EditorModule.DockModule.TabModule.NewElementBoardLabel extends Editor.EditorModule.DockModule.TabModule.BoardLabel
  
  initialize: (options) ->
    super(options)
  
  render: () ->
    super()
    this.$el.attr('data-z', 0)
    this.$el.removeClass('ui-corner-top')
    this.$el.addClass('ui-corner-left')
    this
  
  face: () ->
    icon = new Pettanr.Image.SymbolImg({attr: {src: '/images/new.gif'}})
    linked_elements_tab = new Tag.A({
      attr: {href: '#' + @board().body.dom_id() },
      content: icon.render().el
    })
    this.$el.append(linked_elements_tab.render().el)
  
  add_label: () ->
    this.$el.attr('id', @dom_id())
  
  z: () ->
    parseInt(this.$el.attr('data-z'))
  
class Editor.EditorModule.DockModule.TabModule.NewElementBoardBody extends Editor.EditorModule.DockModule.TabModule.BoardBody
  className: 'new-element-board-body'
  
  initialize: (options) ->
    super(options)
  
  render: () ->
    this.$el.attr('id', @dom_id())
    @buttons = new Editor.EditorModule.DockModule.NewElementButtons({
      parent: this, element_models: @element_models()
    })
    @listenTo(@buttons, 'click', @click_button)
    this.$el.append(@buttons.render().el)
    this
  
  panel: () ->
    @parent.panel
  
  element_models: () ->
    @panel().my_class().child_models()
  
  click_button: (model) ->
    @new_element.remove() if @new_element
    @new_element = new Pettanr.Views[model.singular()].NewElement({
      parent: this, target_model: model
    })
    @listenTo(@new_element, 'pick', @pick)
    this.$el.append(@new_element.clear().el)
  
  pick: (new_item) ->
    @trigger('pick', new_item)
    @new_element.render()
  
class Editor.EditorModule.DockModule.NewElementButtons extends Backbone.View
  tagName: 'div'
  className: 'new-element-buttons'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @element_models = options.element_models
  
  render: () ->
    _.each @element_models, (model) =>
      button = new Editor.EditorModule.DockModule.NewElementButton({
        parent: this, model: model
      })
      @listenTo(button, 'click', @click)
      this.$el.append(button.render().el)
    this
  
  click: (model) ->
    @trigger('click', model)
  
class Editor.EditorModule.DockModule.NewElementButton extends Backbone.View
  tagName: 'div'
  
  initialize: (options) ->
    super(options)
    @parent = options.parent
    @model = options.model
  
  render: () ->
    this.$el.html('')
    icon = new Pettanr.Image.Icon({item: @model})
    linked_icon = new Editor.EditorModule.DockModule.NewElementLinkedButton({
      attr: {href: '#' },
      content: icon.render().el
    })
    @listenTo(linked_icon, 'click', @click)
    this.$el.append(linked_icon.render().el)
    this
  
  click: () ->
    @trigger('click', @model)
  
class Editor.EditorModule.DockModule.NewElementLinkedButton extends Tag.A
  
  click: () ->
    @trigger('click')
    return false
  
