class Locmare.FilerModule.BodyModule.FileBodyModule.FileItem extends Backbone.View
  tagName: 'li'
  
  initialize: (options) ->
    @file_body = options.file_body
    @item = options.item
    @symbol = @module().SymbolItemColumnFactory.factory this, @manifest().symbol, @item
    @caption = @module().CaptionItemColumnFactory.factory this, @manifest().caption, @item
    @summary = @module().SummaryItemColumnFactory.factory this, @manifest().summary, @item
    @icon = @module().IconItemColumnFactory.factory this, @manifest().icon, @item
    @date = @module().DateItemColumnFactory.factory this, @manifest().date, @item
    @edit = @module().EditItemColumnFactory.factory this, @manifest().edit, @item
    @el.className = 'filer-item filer-item-' + @item.item_name()
    @listenTo(@symbol, 'click:symbol', @click_symbol)
    @listenTo(@caption, 'click:caption', @click_caption)
    @listenTo(@icon, 'click:prof', @click_prof)
    @listenTo(@symbol, 'http_get', @http_get)
    @listenTo(@caption, 'http_get', @http_get)
    @listenTo(@summary, 'http_get', @http_get)
    @listenTo(@icon, 'http_get', @http_get)
    @listenTo(@edit, 'http_get', @http_get)
    @listenTo(@edit, 'http_post', @http_post)
    @listenTo(@item, 'destroy', @destroy)
  
  render: () ->
    this.$el.html('')
    if @pick
      this.$el.append(@pick.render().el)
    if @symbol.is_visible()
      this.$el.append(@symbol.render().el)
    if @caption.is_visible()
      this.$el.append(@caption.render().el)
    if @summary.is_visible()
      this.$el.append(@summary.render().el)
    if @icon.is_visible()
      this.$el.append(@icon.render().el)
    if @date.is_visible()
      this.$el.append(@date.render().el)
    if !@pick and @edit.is_visible()
      this.$el.append(@edit.render().el)
    this
  
  filer: () ->
    @file_body.filer()
  
  manifest: () ->
    @filer().manifest
  
  item_name: () ->
    @filer().item_name
  
  model: () ->
    @filer().model
  
  items: () ->
    @filer().items
  
  add_pick: (target_model) ->
    @pick = new Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.Pick.factory({
      parent: this,
      target_model: target_model
    })
    @listenTo(@pick, 'click', @click_pick)
    @render()
  
  click_pick: () ->
    @trigger('click:pick', this)
  
  click_symbol: () ->
    @trigger('click:symbol', this)
  
  click_caption: () ->
    @trigger('click:caption', this)
  
  click_prof: (url) ->
    @trigger('click:prof', this)
    @trigger('http_get', url)
  
  http_get: (url) ->
    @trigger('http_get', url)
  
  http_post: (url) ->
    @trigger('http_post', url)
  
  destroy: (model, collection, options) ->
    @trigger('remove', this)
  
  module: () ->
    Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule


class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.Pick extends Backbone.View
  tagName: 'div'
  
  @factory: (options) ->
    @target_model = options.target_model
    @parent = options.parent
    filer = @parent.filer()
    klass = if filer.item_name == @target_model.item_name()
      Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Inspire
    else if @target_model.is_traceable(filer.item_name)
      Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Trace
    else if filer.item_name == @target_model.pick_item_name()
      Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Pick
    else
      Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.None
    new klass({
      target_model: @target_model
    })
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Base extends Backbone.View
  tagName: 'div'
  
  initialize: (options) ->
    @target_model = options.target_model
    @el.className = 'filer-item-pick'
    @button = @set_button()
  
  render: () ->
    this.$el.html('')
    @listenTo(@button, 'click', @click)
    this.$el.append(@button.render().el)
    this
  
  name: () ->
    'none'
  
  icon: () ->
    new Pettanr.Image.SymbolImg({attr: {src: '/images/' + @name() + '.gif'}})
  
  linked_icon: () ->
    new Tag.A({
      attr: {href: '#'},
      content: @icon().render().el
    })
  
  click: () ->
    @trigger('click', this)
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.None extends Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Base
  
  set_button: () ->
    @button = @icon()
  
  name: () ->
    'none'
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Pick extends Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Base
  
  set_button: () ->
    @button = @linked_icon()
  
  name: () ->
    'pick'
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Inspire extends Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Base
  
  set_button: () ->
    @button = @linked_icon()
  
  name: () ->
    'inspire'
  
class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Trace extends Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.PickModule.Base
  
  set_button: () ->
    @button = @linked_icon()
  
  name: () ->
    'trace'
  
