class Locmare.FormModule.FieldModule.HelperModule.TailAngle extends Locmare.FormModule.FieldModule.HelperModule.Base
  className: 'r-wrap'
  
  # wrapper
  initialize: (options) ->
    super(options)
    @down = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Down({field: @field, helper: this})
    @up = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Up({field: @field, helper: this})
    @reset = new Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Reset({field: @field, helper: this})
    @listenTo(this, 'down', @down_click)
    @listenTo(this, 'up', @up_click)
    @listenTo(this, 'reset', @reset_click)
    @speech_balloon_template = new Pettanr.SpeechBalloonTemplate({
      id: @field.item().get('speech_balloon_template_id')
    })
    @speech_balloon_template.fetch({cache: true}).done =>
      @r_step = @_r_step()
  
  render: () ->
    @attr = {
      style: 'display: block'
    }
    this.$el.attr(@attr)
    this.$el.html('')
    this.$el.append(@down.render().el)
    this.$el.append(@up.render().el)
    this.$el.append(@reset.render().el)
    this
  
  refresh: () -> 
    @set_system_picture_id(@balloon_index())
  
  settings: () ->
    @speech_balloon_template.parsed_settings()
  
  _r_step: () ->
    settings = @settings()
    settings['speech_balloon']['r_step']
  
  system_picture_id: (idx) ->
    settings = @settings()
    settings[idx]['balloon']['system_picture_id']
  
  # balloon r helper
  
  balloon_next_index: (d) ->
    r_val = @field.val()
    v = parseInt(r_val) + @r_step * d
    tr = v % 360
    tr = 360 + tr if tr < 0
    offset = @r_step / 2.0
    idx = Math.floor(((tr + offset) % 360) / @r_step)
    if idx == 0
      ir = 0
    else
      if v < 0
        ir = Math.floor(idx * @r_step) - 360
      else
        ir = Math.floor(idx * @r_step)
    @field.set(ir)
    @field.tag.$el.val(ir)
    idx
  
  balloon_index: () ->
    v = parseInt(@field.val())
    tr = v % 360
    tr = 360 + tr if tr < 0
    offset = @r_step / 2.0
    idx = Math.floor(((tr + offset) % 360) / @r_step)
    idx
  
  refresh_balloon: (idx) ->
    @set_system_picture_id(idx)
  
  set_system_picture_id: (idx) ->
    sp_id = @system_picture_id(idx)
    @field.item().set({
      system_picture_id: sp_id
    }, {silent: true})
    sp_id
  
  down_click: () ->
    idx = @balloon_next_index(-1)
    @refresh_balloon(idx)
    @field.item().trigger('input:r')
  
  up_click: () ->
    idx = @balloon_next_index(1)
    @refresh_balloon(idx)
    @field.item().trigger('input:r')
  
  reset_click: () ->
    @refresh_balloon(0)
    @field.item().trigger('input:r')
  
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Down extends Backbone.View
  tagName: 'button'
  className: 'r-down'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('<')
    this
  
  click: () -> 
    @helper.trigger('down')
    false
    
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Up extends Backbone.View
  tagName: 'button'
  className: 'r-up'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('>')
    this
  
  click: () -> 
    @helper.trigger('up')
    false
  
class Locmare.FormModule.FieldModule.HelperModule.TailAngleModule.Reset extends Backbone.View
  tagName: 'button'
  className: 'r-reset'
  events: {
    'click': 'click'
  }
  
  initialize: (options) ->
    @field = options.field
    @helper = options.helper
  
  render: () ->
    this.$el.html('reset')
    this
  
  click: () -> 
    @field.tag.$el.val(0)
    @helper.trigger('reset')
    false
  
