class Pettanr.Balloon extends Peta.Element
  url: '/balloons/'
  
  @singular: () ->
    'Balloon'
  
  @plural: () ->
    'Balloons'
  
  defaults: {
    id: null,
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    r: 0
  } 
  
  pick: (templates) ->
    # 
    speech_balloon_template = templates.speech_balloon_template
    {
      speech_balloon_template_id: speech_balloon_template.get('id'),
      speech_balloon_template_module_name: speech_balloon_template.get('module_name'),
      speech_balloon_template_settings: speech_balloon_template.get('settings')
    }
  
  speech_balloon: () ->
    new Pettanr.SpeechBalloon({id: @get('speech_balloon_id')})
  
  system_picture: () ->
    new Pettanr.SystemPicture({id: @get('system_picture_id')})
  
  r_url: () ->
    '/system_pictures/' + @system_picture().filename()
  
  symbol_option: () ->
    sb = @speech_balloon()
    sb.fetch({cache: true}).done =>
      sbt = sb.speech_balloon_template()
      sbt.fetch({cache: true}).done =>
        sp = sbt.system_picture()
        sp.fetch({cache: true}).done =>
          @trigger('ready:symbol', sp.tmb_opt_img_tag())
  
  initialize: (attr, options) ->
    super(attr, options)
    if @id
      @url = @url + @id
    @bind('change:width', () ->
      console.log('cng')
    )
  
