class Pettanr.Panel extends Peta.Root
  url: '/panels/'
  
  @singular: () ->
    'Panel'
  
  @plural: () ->
    'Panels'
  
  defaults: {
    id: null,
    width: 500,
    height: 300,
    border: 2,
    publish: 0
  } 
  
  author: () ->
    Pettanr.cache.store(new Pettanr.Author({id: @get('author_id')}, {expire_time: (new Date)}))
  
  pp: () ->
    new Pettanr.PanelPicture({id: @get('pp_id')})
  
  with_elements: () ->
    new Pettanr.Panel.WithElements({id: @get('id')})
  
  overwrite: (options) ->
    operators = options.operators
    return false if not operators.author
    @set('author_id', operators.author.id)
  
  is_visible: (operators) ->
    switch super(operators)
      when null # super return
        return true
      when false
        return false
      else
        return true if @isNew()
        @is_publish()
  
  overwrite: (options) ->
    @set('author_id', options.operators.author.id)
  
  is_usable: (operators) ->
    @is_visible(operators)
  
  is_publish: () ->
    @get('publish') > 0
  
  @licensed_pictures: (panels) ->
    r = {}
    _.each panels, (panel) ->
      _.extend r, panel.licensed_pictures()
    r
  
  licensed_pictures: () ->
    r = {}
    _.each @scenario_elements(), (elm) ->
      return if not elm.my_class().has_picture()
      pid = elm.get('picture_id')
      r[pid] = elm.picture() if not r[pid]
    r
  
  my_url: () ->
    '/' + @path_name() + '/' + @get('id')
  
  initialize: (attr = {}, options = {}) ->
    @set(attr)
    if @get('id')
      @url = @my_url()
    @bind('change:width', () ->
      console.log('cng')
    )
  
class Pettanr.Panel.WithElements extends Pettanr.Panel
  
  fetch: (options) ->
    @url = @my_url() + '?with_elements=true'
    super(options)
  
  save: (attrs) ->
    @url = @my_url()
    method = if @isNew()
      'create'
    else
      'update'
    _this = this
    xhr = @sync(method, this, {
      attrs: {panel: attrs},
      success: (model, response, options) =>
        _this.trigger('save:success', _this, response)
      error: (model, response, options) =>
        _this.trigger('save:fail', _this, response)
    })
    xhr
  
  destroy: (options) ->
    @url = @my_url()
    super(options)
  
