class Pettanr.Speech extends Peta.Element
  url: '/speeches/'
  
  @singular: () ->
    'Speech'
  
  @plural: () ->
    'Speeches'
  
  defaults: {
    id: null,
    x: 0,
    y: 0,
    width: 100,
    height: 100
  } 
  
  pick: (templates) ->
    # 
    speech_balloon_template = templates.speech_balloon_template
    writing_format = templates.writing_format
    {
      speech_balloon_template_id: speech_balloon_template.get('id'),
      speech_balloon_template_module_name: speech_balloon_template.get('module_name'),
      speech_balloon_template_settings: speech_balloon_template.get('settings')
      writing_format_id: writing_format.get('id'),
      writing_format_module_name: writing_format.get('module_name'),
      writing_format_template_settings: writing_format.get('settings')
    }
  
  speech_balloon: () ->
    new Pettanr.SpeechBalloon({id: @get('speech_balloon_id')})
  
  writing_format: () ->
    new Pettanr.WritingFormat({id: @get('writing_format_id')})
  
  @text_align_texts: () -> 
    ['left', 'left', 'right', 'center']
  
  symbol_option: (cb) ->
    sb = @speech_balloon()
    sb.fetch({cache: true}).done =>
      sbt = sb.speech_balloon_template()
      sbt.fetch({cache: true}).done =>
        sp = sbt.system_picture()
        sp.fetch({cache: true}).done =>
          @trigger('ready:symbol', sp.tmb_opt_img_tag())
  
  text_align_text: () ->
    Pettanr.Speech.text_align_texts()[@get('text_align')]
  
  scenario: () ->
    @boosts('read')
    @render(@escape('content'))
    
  
  initialize: (attr, options) ->
    super(attr, options)
    if @id
      @url = @url + @id
  
