class Pettanr.SpeechBalloon extends Peta.Element
  url: '/speech_balloons/'
  
  @singular: () ->
    'SpeechBalloon'
  
  @plural: () ->
    'SpeechBalloons'
  
  defaults: {
    id: null,
    z: null,
    t: null
  } 
  
  @pick_item_name: () ->
    'speech_balloon_template'
  
  @pick_model: () ->
    Manifest.item_name_to_model(@pick_item_name())
  
  @traceable_item_names: () ->
    ['speech', 'balloon']
  
  @is_traceable: (item_name) ->
    _.contains(@traceable_item_names(), item_name)
  
  trace_from_speech: () ->
  
  trace_from_balloon: () ->
  
  pick: (templates) ->
    # 
    speech_balloon_template = templates.speech_balloon_template
    {
      speech_balloon_template_id: speech_balloon_template.get('id'),
      speech_balloon_template_module_name: speech_balloon_template.get('module_name'),
      speech_balloon_template_settings: speech_balloon_template.get('settings')
    }
  
  panel: (options = {}) ->
    new Pettanr.Panel({id: @get('panel_id')}, options)
  
  speech_balloon_template: () ->
    new Pettanr.SpeechBalloonTemplate({id: @get('speech_balloon_template_id')})
  
  @has_picture: () ->
    false
  
  symbol_option: () ->
    sbt = @speech_balloon_template()
    sbt.fetch({cache: true}).done =>
      sp = sbt.system_picture()
      sp.fetch({cache: true}).done =>
        @trigger('ready:symbol', sp.tmb_opt_img_tag())
  
  filer_caption: () ->
    @fetch({cache: true}).done =>
      caption = @escape('caption')
      @trigger('ready:caption', caption)
  
  plain_scenario: () ->
    @get('caption')
  
  element_face: () ->
    new Pettanr.Views.SpeechBalloon.ElementFace({element: this})
  
  initialize: (attr, options) ->
    super(attr, options)
    if @id
      @url = @url + @id
  
