class Pettanr.SystemPicture extends Peta.SystemResource
  url: '/system_pictures/'
  
  @singular: () ->
    'SystemPicture'
  
  @plural: () ->
    'SystemPictures'
  
  defaults: {
    id: null
  } 
  
  picture: () ->
    new Pettanr.Picture({id: @get('picture_id')})
  
  filename: () ->
    @get('id') + '.' + @get('ext')
  
  mime_type: () ->
    'image/' + @get('ext')
  
  r_url: () ->
    '/system_pictures/' + @filename()
  
  opt_img_tag: () ->
    {src: @r_url(), width: @get('width'), height: @get('height')}
  
  tmb_opt_img_tag: () ->
    new Pettanr.Image.SymbolPicture({
      attr: {
        src: @r_url()
      },
      picture: this
    })
  
  symbol_option: () ->
    @fetch({cache: true}).done =>
      @trigger('ready:symbol', @tmb_opt_img_tag())
  
  initialize: () ->
    if @id
      @url = @url + @id
  
