class Pettanr.Views.SpeechBalloon.NewElement extends Backbone.View
  tagName: 'div'
  className: 'new-element-body'
  
  initialize: (options) ->
    @parent = options.parent
    @target_model = options.target_model
    @pick_model = @target_model.pick_model()
  
  clear: () ->
    this.$el.html('')
    params = {
      controller: @pick_model.path_name(), action: 'index',
      page_size: 6, format: 'html'
    }
    @dialog().start(@target_model, params, null)
    @listenTo(@dialog(), 'pick', @pick)
    this
  
  render: () ->
    this.$el.html('')
    this
  
  pick: (item) ->
    @listenTo(this, 'ready', @ready)
    if item.item_name() == @target_model.item_name()
      # Inspire
      new_item = new @target_model(item.attributes)
      @trigger('ready', new_item)
    else if @target_model.is_traceable(item.item_name())
      # Trace
      n = @target_model['trace_from_' + item.item_name()]
      n()
    else if item.item_name() == @target_model.pick_item_name()
      # Pick
      speech_balloon_template = item
      writing_format = new Pettanr.WritingFormat({id: 1})
      writing_format.fetch({cache: true}).done =>
        templates = {
          speech_balloon_template: speech_balloon_template,
          writing_format: writing_format
        }
        new_item = new @target_model()
        new_item.set(new_item.pick(templates), {silent: true})
        new_item.boosts 'post'
        new_item.supply_default(templates)
        # prepare balloon
        balloon = new Pettanr.Balloon()
        balloon.set(balloon.pick(templates), {silent: true})
        balloon.boosts 'post'
        balloon.supply_default(templates)
        # prepare speech
        speech = new Pettanr.Speech()
        speech.set(speech.pick(templates), {silent: true})
        speech.boosts 'post'
        speech.supply_default(templates)
        # join elements
        new_item.set({balloon: balloon, speech: speech}, {silent: true})
        @trigger('ready', new_item)
  
  ready: (new_item) ->
    @dialog().stop()
    @trigger('pick', new_item)
  
  dock: () ->
    @parent.dock()
  
  editor: () ->
    @dock().editor()
  
  dialog: () ->
    @editor().dialog
  
