class ComicsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_filter :authenticate_reader, :only => [
      :index, :show, :play, :by_story, :by_author
    ]
    before_filter :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_filter :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_story
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def show_html_format format
    format.html {
      @play_list = Locmare::ListGroup.list(
        'comic_stories', 'by_comic', @operators, 
        {:id => @item.id, :page_size => -1}  # set no limit options
      )
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
      format.atom 
      format.rss 
    end
  end
  
  def play
    set_play
    @list.options.merge!({'page_size' => -1})    # no limit no pager
    @list.reset
    play_list
    respond_to do |format|
      format.html {
        if @item.own? @operators
          @new_story_items = assist_items('home', 'stories')
        end
      }
      list_json_format @list, format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_create
  end
  
  def update
    set_edit
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = params[@my_model_class.item_name]
    @item.overwrite @operators
    render_update
  end
  
  def destroy
    @item = Comic.edit(params[:id], @operators)
    respond_to do |format|
      if @item.destroy_with_leafs
        flash[:notice] = I18n.t('flash.notice.destroyed', :model => Comic.model_name.human)
        format.html { redirect_to '/home/comics' }
        format.json { head :ok }
      else
        flash[:notice] = I18n.t('flash.notice.not_destroyed', :model => Comic.model_name.human)
        format.html { redirect_to @item }
        format.json { render json: @item.errors, status: :unprocessable_entity }
      end
    end
  end
end
