ManifestBase.require_modules "manifest/controller/action/", 
  %w|base list show new edit create update destroy|

module Manifest
  module ControllerModule
    class ActionFactory < ManifestBase::Factory
      include ActionModule
      
      def self.types
        {
          'list' => ActionList, 'show' => ActionShow, 
          'new' => ActionNew, 'edit' => ActionEdit, 
          'create' => ActionCreate, 'update' => ActionUpdate, 'destroy' => ActionDestroy
        }
      end
      
      def self.default_type
        'list'
      end
      
    end
    
  end
end
